import processing.sound.*;


// Image files
PImage background;
PImage cat;

// Sound files
SoundFile backgroundMusic;
SoundFile catAlive;
SoundFile catDead;

palmTree pt;
PFont f;


int interfaceState = 1;
int point = 0;
int max = 0; 
int x = -200, y;
int catFallingSpeed = 0;
int treeX[] = new int[2];
int treeY[] = new int[2];



void setup() {
  size(800,600);
  fill(0);
  textSize(40); 
  
  background =loadImage("background.jpg");
  cat =loadImage("cat.png");
  cat.resize(0,70);
  
  backgroundMusic = new SoundFile(this,"jazz.wav");
  backgroundMusic.play();
  catAlive = new SoundFile(this, "catAlive.wav");
  catDead = new SoundFile(this, "catDead.wav");
  
  pt = new palmTree();
}

boolean catDeadSoundPlayed = false;
int closestPillar = 0;

void draw() { 
  
  if(interfaceState == 0) {
    imageMode(CORNER);
    image(background, x, 0);
    image(background, x+background.width, 0);
    
    //Make the background move to create the illusion that the cat is flying forwards
    x -= 5;
    catFallingSpeed += 1;
    y += catFallingSpeed;
    
    if(x <= -background.width) x = 0;
    for(int i = 0 ; i < 2; i++) {
      imageMode(CENTER);
      
      //Create the gap between two trees
      pt.draw(treeX[i], treeY[i] - 150, false);
      pt.draw(treeX[i], treeY[i] + 150, true);
      
      if(treeX[i] < 0) {
        treeY[i] = (int)random(200,height-200);
        treeX[i] = width;
        //point++;
      }
      if (treeX[i] < width/2 && i == closestPillar) {
        max = max(++point, max);
        closestPillar = 1 - closestPillar;}
        
      //Conditions when the game ends inclcuding reaching the boundaries or colliding with the palm tree blocks
      if (y > height || y < 0 || (abs(width/2-treeX[i])<25 && abs(y-treeY[i])>100)) interfaceState=1;
      treeX[i] -= 5;
    }
    image(cat, width/2, y);
    text(""+point, 20, 50);//width/2-15, 10);
  }
  else if (interfaceState==1) {
    if (!catDeadSoundPlayed){
      catDead.play();
      catDeadSoundPlayed = true;
    }
    imageMode(CENTER);
    // change to menu image
    image(background, width/2,height/2);
    text("High Score: "+max, 50, width/2);
    f = createFont("Courier New", 30);
    textFont(f);
  }
}


void mousePressed() {
  catAlive.play();
  catFallingSpeed = -17;
  if(interfaceState==1) {
    treeX[0] = width;
    treeY[0] = y = height/2;
    treeX[1] = width*3/2;
    treeY[1] = 300;
    x = interfaceState = point = 0;
    catDeadSoundPlayed = false;
  }
}
